void d160810390_calc_num_of_overlaps_between_two_sets_of_ranges(int *arg_num_segs_set1, int *startbp_set1, int *endbp_set1, int *arg_num_segs_set2, int *startbp_set2, int *endbp_set2, int* ret_num_segs){
	
	int num_segs_set1 = arg_num_segs_set1[0];
	int num_segs_set2 = arg_num_segs_set2[0];

	printf("num_segs_set1 = %d\n", num_segs_set1);
	printf("num_segs_set2 = %d\n", num_segs_set2);

	

	int genome_endbp = endbp_set1[num_segs_set1-1];
	if(endbp_set1[num_segs_set1-1] < endbp_set2[num_segs_set2-1]){
		genome_endbp = endbp_set2[num_segs_set2-1];
	}

	printf("genome_endbp = %d\n", genome_endbp);

	int* arr_genome_set1 = (int*)malloc((genome_endbp+1)*sizeof(int));
	int curbp;
	for(curbp = 1; curbp <= genome_endbp; curbp++){
		arr_genome_set1[curbp] = 0;
	}

	int i;
	for(i = 1; i <= num_segs_set1; i++){

		int startbp = startbp_set1[i-1];
		int endbp = endbp_set1[i-1];

		for(curbp = startbp; curbp <= endbp; curbp++){
			arr_genome_set1[curbp] = i;
		}
	}

	int* arr_genome_set2 = (int*)malloc((genome_endbp+1)*sizeof(int));
	
	for(curbp = 1; curbp <= genome_endbp; curbp++){
		arr_genome_set2[curbp] = 0;
	}

	for(i = 1; i <= num_segs_set2; i++){

		int startbp = startbp_set2[i-1];
		int endbp = endbp_set2[i-1];

		for(curbp = startbp; curbp <= endbp; curbp++){
			arr_genome_set2[curbp] = i;
		}
	}

/*
        for(curbp = 1; curbp <= genome_endbp; curbp++){
                printf("%d\t%d\n",arr_genome_set1[curbp], arr_genome_set2[curbp]);
        }
*/

	int prev_segid_set1 = 0;
	int prev_segid_set2 = 0;
	int cur_segid_set1 = 0;
	int cur_segid_set2 = 0;
	int num_segs_res = 0;
	for(curbp = 1; curbp <= genome_endbp; curbp++){
		cur_segid_set1 = arr_genome_set1[curbp];
		cur_segid_set2 = arr_genome_set2[curbp];
		if(cur_segid_set1 > 0 && cur_segid_set2 > 0){
			if(prev_segid_set1 != cur_segid_set1 || prev_segid_set2 != cur_segid_set2){
				num_segs_res++;
				prev_segid_set1 = cur_segid_set1;
				prev_segid_set2 = cur_segid_set2;
			}
		}
	}

	ret_num_segs[0] = num_segs_res;

	free(arr_genome_set1);
	free(arr_genome_set2);
	
}
