#include <stdio.h>
#include <stdlib.h>
#include <math.h>

//10 : new line

//62 : >

//97 : a
//99 : c
//103 : g
//116 : t

//65 : A
//67 : C
//71 : G
//84 : T

//78 : N


void d170626121_get_gc_from_starts_and_ends(char** path_ref_seq, int * size, int * starts, int * ends, int * cnt_gc, int * cnt_at, int * cnt_N){
  
  //FILE *f = fopen("/DAS_Storage2/hjang/cnv_detection_sync/sub.140102.reference_sequence/160601666.ucsc_hg19_chromFa/chr22.fa", "rb");
  //FILE *f = fopen("/DAS_Storage2/hjang/cnv_detection_sync/sub.140102.reference_sequence/160601666.ucsc_hg19_chromFa/chr21_gl000210_random.fa", "rb");
  FILE *f = fopen(path_ref_seq[0], "rb");
  fseek(f, 0, SEEK_END);
  
  long fsize = ftell(f);
  fseek(f, 0, SEEK_SET);  //same as rewind(f);
  
  unsigned char *string = malloc(fsize + 1);
  fread(string, fsize, 1, f);
  fclose(f);

  unsigned char * seq_gc = malloc(fsize + 1);

  int cnt_bases = 0;

  int i;
  for(i = 0; i < fsize; i++){
    //printf("%d\n", (int)string[i]);
    
    int base = (int)string[i];
    
    //convert 'a' to 'A'
    if(97 <= base && base <= 116){
      base = base - 32;
    }

    if(base == '>'){
      while(string[i] != '\n') i++;
    }else{
      if(base == 'N'){
        seq_gc[cnt_bases++] = 0;
        //printf("%d\t%c\n", base, base);
      }else if(base == 'A'){
        seq_gc[cnt_bases++] = 2;
        //printf("%d\t%c\n", base, base);
      }else if(base == 'T'){
        seq_gc[cnt_bases++] = 2;
        //printf("%d\t%c\n", base, base);
      }else if(base == 'G'){
        seq_gc[cnt_bases++] = 1;
        //printf("%d\t%c\n", base, base);
      }else if(base == 'C'){
        seq_gc[cnt_bases++] = 1;
        //printf("%d\t%c\n", base, base);
      }else if(base == '\n'){
        
      }else{
        printf("Incorrect alphabet : %c. Exit\n", base);
        exit(1);
      }
    }
  }
  
  free(string);
  
  //for(i = 0; i < cnt_bases; i++){
  //  printf("%d\n", seq_gc[i]);
  //}

  for(i = 0; i < size[0]; i++){
    cnt_gc[i] = 0;
    cnt_at[i] = 0;
    cnt_N[i] = 0;
    for(int j = (starts[i] - 1); j <= (ends[i] - 1); j++){
      if(seq_gc[j] == 1){
        cnt_gc[i]++;
      }else if(seq_gc[j] == 2){
        cnt_at[i]++;
      }else{
        cnt_N[i]++;
      }
    }
  }

  free(seq_gc);
}
